<?php
/**
 * Plugin Name: Gallery Pro - Responsive Photo Gallery, Light box Gallery, Video Gallery
 * Version: 1.7.5
 * Description: Gallery Pro is the leading plugin for building beautiful mobile-friendly galleries in a few minutes.its Stunning gallery layouts, responsive, retina-ready, lightning fast, easy to use. Built to be highly configurable and extensible for website owners and individuals.
 * Author: Weblizar
 * Author URI: http://weblizar.com/plugins/
 * Plugin URI: https://wordpress.org/plugins/gallery-pro/
 */

/**
 * Constant Variable
 */
define( "WL_GP_TEXTDOMAIN", "weblizar-gp" );
define( "WGP_PLUGIN_URL", plugin_dir_url( __FILE__ ) );

register_activation_hook( __FILE__, 'lk_DefaultSettingsPro' );
function lk_DefaultSettingsPro() {
	$lk_defaultsetting = base64_encode( serialize( array(
		'wgp_Color'              => "#e3e3e3",
		'lk_show_Gallery_title'  => "Yes",
		'lk_show_image_label'    => "Yes",
		'lk_show_gallery_layout' => "3",
		'lk_label_Color'         => "#666",
		'lk_desc_font_Color'     => "#777777",
		'lk_btn_Color'           => "#428bca",
		'lk_btn_font_Color'      => "#FFF",
		'lk_font_style'          => "Courgette",
		'lk_Custom_CSS'          => "",
		'lk_show_img_desc'       => "Yes",
		'lk_Light_Box'           => "lightbox3",
		'lk_open_link'           => "_blank",
		'lk_button_title'        => "Zoom"
	) ) );
	add_action( "lksg_setting", $lk_defaultsetting );
}

/**
 * Crop Images In Desire Format
 */
add_image_size( 'lksg_gallery_admin_thumb', 300, 300, array( 'top', 'center' ) );
add_image_size( 'lksg_gallery_admin_medium', 400, 400, array( 'top', 'center' ) );
add_image_size( 'lksg_gallery_admin_large', 500, 500, array( 'top', 'center' ) );
add_image_size( 'lksg_gallery_admin_medium_auto', 400, 9999, array( 'top', 'center' ) );
add_image_size( 'lksg_gallery_admin_large_auto', 500, 9999, array( 'top', 'center' ) );


function admin_content_GP_144936() {
	global $pagenow;
	$gp_screen = get_current_screen();
	if(isset($gp_screen)){
		if ( $pagenow == 'edit.php' && $gp_screen->post_type == 'acme_product' ) {
		include( 'gallery-pro-banner.php' );
		}
	}	
}
add_action( 'in_admin_header', 'admin_content_GP_144936' );
add_action( 'admin_menu', 'submenu_SettingsPage' );
function submenu_SettingsPage() {
	add_submenu_page( 'edit.php?post_type=acme_product', 'Help and Support', 'Help and Support', 'administrator', 'lksg_gallery_pro', 'lksg_get_image_gallery_pro_page_function' );
	add_submenu_page( 'edit.php?post_type=acme_product', 'Pro Screenshots', 'Pro Screenshots', 'administrator', 'lksg_gallery_Pro_Screenshots', 'lksg_get_image_gallery_Pro_Screenshots_function' );
	add_submenu_page( 'edit.php?post_type=acme_product', 'Recommendation', 'Recommendation', 'administrator', 'lksg_gallery_pro_recommendation', 'lksg_get_image_gallery_pro_recommendation_function' );
}

function lksg_get_image_gallery_pro_page_function() {
	require_once( "gallery-pro-help-and-support.php" );
	wp_enqueue_style( 'custom_css-css', WGP_PLUGIN_URL . 'css/custom_css.css' );
}

function lksg_get_image_gallery_Pro_Screenshots_function() {
	wp_enqueue_style( 'lksg-font-awesome-5', WGP_PLUGIN_URL . 'css/font-awesome-latest/css/fontawesome-all.min.css' );
	wp_enqueue_style( 'lksg-pricing-table-css', WGP_PLUGIN_URL . 'css/pricing-table.css' );
	wp_enqueue_style( 'lksg-boot-strap-admin', WGP_PLUGIN_URL . 'css/bootstrap-admin.css' );

	// code-mirror css & js for custom css section
	wp_enqueue_style( 'wgp_codemirror-css', WGP_PLUGIN_URL . 'css/codemirror/codemirror.css' );
	wp_enqueue_style( 'wgp_blackboard', WGP_PLUGIN_URL . 'css/codemirror/blackboard.css' );
	wp_enqueue_style( 'wgp_show-hint-css', WGP_PLUGIN_URL . 'css/codemirror/show-hint.css' );
	wp_enqueue_script( 'wgp_codemirror-js', WGP_PLUGIN_URL . 'css/codemirror/codemirror.js', array( 'jquery' ) );
	wp_enqueue_script( 'wgp_css-js', WGP_PLUGIN_URL . 'css/codemirror/wgp-css.js', array( 'jquery' ) );
	wp_enqueue_script( 'wgp_css-hint-js', WGP_PLUGIN_URL . 'css/codemirror/css-hint.js', array( 'jquery' ) );

	require_once( "get-gallery-pro-weblizar.php" );
}

/*Plugin Setting Link*/
function weblizar_gallerypro_add_settings_link( $links ) {
	$gallery_pro_link         = '<a href="https://weblizar.com/plugins/gallery-pro/" target="_blank" style="font-weight:700; color:#e35400">Get Premium</a>';
	$settings_link_gallerypro = '<a href="edit.php?post_type=acme_product">' . __( 'Settings' ) . '</a>';
	array_unshift( $links, $settings_link_gallerypro );
	array_unshift( $links, $gallery_pro_link );

	return $links;
}

$plugin_gallerypro = plugin_basename( __FILE__ );
add_filter( "plugin_action_links_$plugin_gallerypro", 'weblizar_gallerypro_add_settings_link' );

function lksg_get_image_gallery_pro_recommendation_function() {
	//css
	wp_enqueue_style( 'recom2', WGP_PLUGIN_URL . 'css/recom.css' );
	require_once( "recommendations.php" );
}

class lksg {
	private static $instance;
	private $admin_thumbnail_size = 150;
	private $thumbnail_size_w = 150;
	private $thumbnail_size_h = 150;
	var $counter;

	public static function forge() {
		if ( ! isset( self::$instance ) ) {
			$className      = __CLASS__;
			self::$instance = new $className;
		}

		return self::$instance;
	}

	private function __construct() {
		$this->counter = 0;
		add_action( 'wp_enqueue_scripts', array( &$this, 'front_display_style' ) );
		if ( is_admin() ) {
			add_action( 'plugins_loaded', array( &$this, 'GetReadyTranslation' ) );
			add_action( 'init', array( &$this, 'my_cpt' ) );
			add_action( 'wp_ajax_lksgallery_get_thumbnail', array( &$this, 'lks_ajax_get_thumb' ) );

			add_action( 'add_meta_boxes', array( &$this, 'add_custom_meta_box' ) );
			add_action( 'save_post', array( &$this, 'lksg_add_image_meta_box_save' ) );
			add_action( 'save_post', array( &$this, 'lksg_settings_meta_save' ) );
			add_action( 'admin_init', array( &$this, 'add_custom_meta_box' ) );
		}
	}

	public function GetReadyTranslation() {
		load_plugin_textdomain( WL_GP_TEXTDOMAIN, false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );
	}

	public function front_display_style() {
		wp_enqueue_style( 'mystyle-5', WGP_PLUGIN_URL . 'css/display_frant_css.css' );
		wp_enqueue_style( 'mystyle-6', WGP_PLUGIN_URL . 'css/bootstrap.css' );
		wp_enqueue_style( 'mystyle-8', WGP_PLUGIN_URL . 'js/grid-folio/jquery.wm-gridfolio-1.0.min.css' );
		wp_enqueue_script( 'jquery' );
		wp_enqueue_script( 'myscript-3', WGP_PLUGIN_URL . 'js/grid-folio/jquery.wm-gridfolio-1.0.min.js' );

		/**
		 * Load Light Box 1 Swipebox JS CSS
		 */
		wp_enqueue_style( 'wl-lksg-swipe-css', WGP_PLUGIN_URL . 'lightbox/swipebox/css/swipebox.css' );
		wp_enqueue_script( 'wl-lksg-swipe-js', WGP_PLUGIN_URL . 'lightbox/swipebox/js/jquery.swipebox.js' );
	}

	public function add_custom_meta_box() {
		add_meta_box( 'custom_meta_box', 'Photo Gallery shortcode', array(
			&$this,
			'meta_box_function'
		), 'acme_product', 'side', 'low' );
		add_meta_box( 'custom_meta_Pro_Features', 'Gallery Pro Weblizar', array(
			&$this,
			'meta_box_function_Pro_Features'
		), 'acme_product', 'side', 'low' );
		add_meta_box( 'custom_meta_rate', 'Show us some love, Rate Us', array(
			&$this,
			'meta_box_function_rate'
		), 'acme_product', 'side', 'low' );
		add_meta_box( 'custom_meta_upgrade_version', 'Upgrade To Pro Version', array(
			&$this,
			'meta_box_function_upgrade'
		), 'acme_product', 'side', 'low' );
		add_meta_box( 'add_img_box', 'Add Images', array(
			&$this,
			'add_image_meta_box'
		), 'acme_product', 'normal', 'low' );
		add_meta_box( 'gallery_setting', 'Apply Setting On Photo Gallery', array(
			&$this,
			'setting_meta_box_function'
		), 'acme_product', 'normal', 'low' );
	}

	public function meta_box_function() { ?>
        <p><?php _e( 'Use below shortcode in any Page/Post to publish your gallery', WL_GP_TEXTDOMAIN ); ?></p>
        <input type="text" value="<?php echo "[WG id=" . get_the_ID() . "]"; ?>" readonly/>
		<?php
	}

	public function meta_box_function_rate() { ?>
        <div align="center">
            <p><?php _e( 'Please Review & Rate Us On WordPress', WL_GP_TEXTDOMAIN ); ?></p>
            <a class="lk_upgrade-to-pro-demo faglk-rate-us" style=" text-decoration: none; height: 40px; width: 40px;"
               href="https://wordpress.org/plugins/gallery-pro/" target="_blank">
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
            </a>
        </div>
        <div class="lk_upgrade-to-pro-demo" style="text-align:center;margin-bottom:10px;margin-top:10px;">
            <a href="https://wordpress.org/plugins/gallery-pro/" target="_blank"
               class="button button-primary button-hero"><?php _e( 'RATE US', WL_GP_TEXTDOMAIN ); ?></a>
        </div>
		<?php
	}

	public function meta_box_function_upgrade() { ?>
        <div class="lk_upgrade-to-pro-demo" style="text-align:center;margin-bottom:10px;margin-top:10px;">
            <a href="http://demo.weblizar.com/flickr-album-gallery-pro/" target="_new"
               class="button button-primary button-hero"><?php _e( 'View Live Demo', WL_GP_TEXTDOMAIN ); ?></a>
        </div>
        <div class="lk_upgrade-to-pro-admin-demo" style="text-align:center;margin-bottom:10px;">
            <a href="http://demo.weblizar.com/gallery-pro-by-weblizar/" target="_new"
               class="button button-primary button-hero"><?php _e( 'View Admin Demo', WL_GP_TEXTDOMAIN ); ?></a>
        </div>
        <div class="lk_upgrade-to-pro" style="text-align:center;margin-bottom:10px;">
            <a href="https://weblizar.com/plugins/gallery-pro/" target="_new"
               class="button button-primary button-hero"><?php _e( 'Upgarde To Pro', WL_GP_TEXTDOMAIN ); ?></a>
        </div>
		<?php
	}

	public function meta_box_function_Pro_Features() {
		$imgpath = WGP_PLUGIN_URL . "images/gpw_pro.jpg";
		?>
        <div class="">
            <div class="update_pro_button"><a target="_blank"
                                              href="https://weblizar.com/plugins/gallery-pro/"><?php _e( 'Buy Now $9', WL_GP_TEXTDOMAIN ); ?></a>
            </div>
            <div class="update_pro_image">
                <img class="gpw_getpro" src="<?php echo $imgpath; ?>">
            </div>
            <div class="update_pro_button">
                <a class="upg_anch" target="_blank"
                   href="https://weblizar.com/plugins/gallery-pro/"><?php _e( 'Buy Now $9', WL_GP_TEXTDOMAIN ); ?></a>
            </div>
        </div>
		<?php
	}

	public function setting_meta_box_function( $post ) {
		require_once( 'gallery-pro-setting.php' );
	}

	public function add_image_meta_box( $post ) { ?>
        <div class="image_countainer row">
            <input type="hidden" id="lksg_wl_action" name="lksg_wl_action" value="lksg-save-settings">
            <ul class="" id="lksgallery_thumbs">
				<?php
				$id                    = $post->ID;
				$lksg_AllPhotosDetails = unserialize( base64_decode( get_post_meta( $id, 'lksg_all_photos_details', true ) ) );
				$i                     = 0;
				$TotalImg              = get_post_meta( $id, 'lksg_total_images_count', true );
				//print_r($lksg_AllPhotosDetails);

				if ( $TotalImg ) {
					foreach ( $lksg_AllPhotosDetails as $data ) {
						$name                 = $data['lksg_image_label'];
						$url_c                = $data['lksg_image_url'];
						$lksg_img_thumb       = $data['lksg_img_thumb'];
						$lksg_img_medium      = $data['lksg_img_medium'];
						$lksg_img_large       = $data['lksg_img_large'];
						$lksg_img_medium_auto = $data['lksg_img_medium_auto'];
						$lksg_img_large_auto  = $data['lksg_img_large_auto'];
						$img_desc             = $data['img_desc'];
						$lksg_video_link      = $data['lksg_video_link'];
						$lksg_external_link   = $data['lksg_external_link'];
						$lksg_portfolio_type  = $data['lksg_portfolio_type'];
						?>
                        <li class="choose_image_entry">
                            <a href="" class="lksgallery_remove_image"><img
                                        src="<?php echo WGP_PLUGIN_URL . 'images/Close-icon-new.png'; ?>"></a>
                            <img src="<?php echo esc_url( $lksg_img_thumb ); ?>">
                            <input type="text" name="lksg_image_url[]" id="lksg_image_url[]"
                                   value="<?php echo esc_url( $url_c ); ?>" readonly="readonly" style="display:none;"/>
                            <input type="text" id="lksg_img_thumb[]" name="lksg_img_thumb[]" class="lksg_label_text"
                                   value="<?php echo esc_url( $lksg_img_thumb ); ?>" readonly="readonly"
                                   style="display:none;"/>
                            <input type="text" id="lksg_img_medium[]" name="lksg_img_medium[]" class="lksg_label_text"
                                   value="<?php echo esc_url( $lksg_img_medium ); ?>" readonly="readonly"
                                   style="display:none;"/>
                            <input type="text" id="lksg_img_large[]" name="lksg_img_large[]" class="lksg_label_text"
                                   value="<?php echo esc_url( $lksg_img_large ); ?>" readonly="readonly"
                                   style="display:none;"/>
                            <input type="text" id="lksg_img_medium_auto[]" name="lksg_img_medium_auto[]"
                                   class="lksg_label_text" value="<?php echo esc_url( $lksg_img_medium_auto ); ?>"
                                   readonly="readonly" style="display:none;"/>
                            <input type="text" id="lksg_img_large_auto[]" name="lksg_img_large_auto[]"
                                   class="lksg_label_text" value="<?php echo esc_url( $lksg_img_large_auto ); ?>"
                                   readonly="readonly" style="display:none;"/>


                            <select name="lksg_portfolio_type[]" id="lksg_portfolio_type[]" class="s<?php echo $i; ?>"
                                    style="width:100%;">
                                <optgroup label="Select Type">
                                    <option value="image" <?php selected( $lksg_portfolio_type, 'image' ); ?>><i
                                                class="fa fa-image"></i><?php _e( 'Image', WL_GP_TEXTDOMAIN ); ?>
                                    </option>
                                    <option value="video" <?php selected( $lksg_portfolio_type, 'video' ); ?>><i
                                                class="fa fa-youtube-play"><?php _e( 'Video', WL_GP_TEXTDOMAIN ); ?>
                                    </option>
                                    <option value="link" <?php selected( $lksg_portfolio_type, 'link' ); ?>><i
                                                class="fa fa-link"></i><?php _e( 'Link', WL_GP_TEXTDOMAIN ); ?></option>
                                </optgroup>
                            </select>

                            <label><?php _e( 'Label', WL_GP_TEXTDOMAIN ); ?></label>
                            <input type="text" placeholder="<?php _e( 'Enter Image label', WL_GP_TEXTDOMAIN ); ?>"
                                   name="lksg_image_label[]" class="lksg_label_text"
                                   value="<?php echo esc_attr( $name ); ?>">

                            <label><?php _e( 'Video URL', WL_GP_TEXTDOMAIN ); ?> <a
                                        href="http://weblizar.com/get-youtube-vimeo-video-url/"
                                        target="_blank"><strong><?php _e( 'Help', WL_GP_TEXTDOMAIN ); ?></strong></a></label>
                            <input type="text" id="lksg_video_link[]" name="lksg_video_link[]"
                                   placeholder="<?php _e( 'Enter Youtube/Vimeo Video URL', WL_GP_TEXTDOMAIN ); ?>"
                                   class="pgpp_label_text video<?php echo $i; ?>"
                                   value="<?php echo esc_url( $lksg_video_link ); ?>" <?php if ( $lksg_portfolio_type == 'link' || $lksg_portfolio_type == 'image' ) {
								echo "readonly";
							} ?>>

                            <label><?php _e( 'Link', WL_GP_TEXTDOMAIN ); ?></label>
                            <input type="text" id="lksg_external_link[]" name="lksg_external_link[]"
                                   placeholder="<?php _e( 'Enter Link URL', WL_GP_TEXTDOMAIN ); ?>"
                                   class="lksg_label_text link<?php echo $i; ?>"
                                   value="<?php echo esc_url( $lksg_external_link ); ?>" <?php if ( $lksg_portfolio_type == 'video' || $lksg_portfolio_type == 'image' ) {
								echo "readonly";
							} ?>>

                            <label><?php _e( 'Description', WL_GP_TEXTDOMAIN ); ?></label>
                            <textarea name="img_desc[]" id="img_desc[]"
                                      placeholder="<?php _e( 'Description', WL_GP_TEXTDOMAIN ); ?>"
                                      class="gal_richeditbox_<?php echo $i; ?>"><?php echo htmlentities( $img_desc ); ?></textarea>
                            <button type="button" class="btn btn-md btn-info btn-block" data-toggle="modal"
                                    data-target="#myModalgp"
                                    onclick="gal_richeditor(<?php echo $i; ?>)"><?php _e( 'Use Rich Text Editor', WL_GP_TEXTDOMAIN ); ?>
                                <i class="fa fa-edit"></i></button>
                        </li>
						<?php
						$i ++;
					}
				} else {
					$TotalImg = 0;
				}
				?>
            </ul>
            <script>
                jQuery('select').on('change', function () {
                    //alert( this.value );
                    var selected_value = this.value;
                    var class_name = jQuery(this).attr("class");
                    var class_suffix = class_name.match(/\d+/);
                    if (selected_value == 'image') {
                        jQuery(".video" + class_suffix).attr('readonly', 'readonly');
                        jQuery(".link" + class_suffix).attr('readonly', 'readonly');
                    }
                    if (selected_value == 'video') {
                        jQuery(".video" + class_suffix).removeAttr('readonly');
                        jQuery(".link" + class_suffix).attr('readonly', 'readonly');
                    }
                    if (selected_value == 'link') {
                        jQuery(".video" + class_suffix).attr('readonly', 'readonly');
                        jQuery(".link" + class_suffix).removeAttr('readonly');
                    }
                });
            </script>
            <!-- <div id="clearfix"></div> -->
            <!--rich editor modal-->
            <div class="modal fade" id="myModalgp" role="dialog">
                <div class="modal-dialog">
                    <!-- Modal content-->
                    <div class="modal-content">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal">&times;</button>
                            <h4 class="modal-title"><i class="fa fa-edit"
                                                       style="font-size:23px"></i> <?php _e( 'Rich Editor', WL_GP_TEXTDOMAIN ); ?>
                            </h4>
                        </div>
                        <div class="modal-body">
                            <p>
								<?php
								$gal_box       = '';
								$gal_editor_id = 'gal_fetch_wpeditor_data';
								$gal_settings  = array(
									'media_buttons' => false,
									'quicktags'     => array( 'buttons' => 'strong,em,del,link,close' )
								); // for remove media button from editor
								//wp_editor( $gal_box, $gal_editor_id); // with media button
								wp_editor( $gal_box, $gal_editor_id, $gal_settings ); // without media button
								?>
                                <input type="hidden" value="" id="gal_fetch_wpelement" name="gal_fetch_wpelement"/>
                            </p>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-default" onclick="gal_richeditor_putdata()"
                                    data-dismiss="modal"><?php _e( 'Continue', WL_GP_TEXTDOMAIN ); ?></button>
                            <button type="button" class="btn btn-default"
                                    data-dismiss="modal"><?php _e( 'Exit', WL_GP_TEXTDOMAIN ); ?></button>
                        </div>
                    </div>
                </div>
            </div>
            <!--rich editor modal-->
        </div>
        <div class="controlbtn row">
            <div class="add_new_img col-md-3" data-uploader_title="Upload Image" data-uploader_button_text="Select">
                <div class="dashicons dashicons-plus"></div>
                <p>
					<?php _e( 'Add New Image', WL_GP_TEXTDOMAIN ); ?>
                </p>
            </div>
            <div id="all_delete_btn" class="del_gp_img col-md-3" data-uploader_title="Upload Image"
                 data-uploader_button_text="Select">
                <div class="dashicons dashicons-trash"></div>
                <p>
					<?php _e( 'Delete All Image', WL_GP_TEXTDOMAIN ); ?>
                </p>
            </div>
        </div>

        <script>
            function gal_richeditor(id) {
                var galricheditdata = jQuery(".gal_richeditbox_" + id).val();
                jQuery("#gal_fetch_wpeditor_data").val(galricheditdata);
                jQuery("#gal_fetch_wpeditor_data-html").click();
                jQuery("#gal_fetch_wpelement").val(id);
            }

            function gal_richeditor_putdata() {
                jQuery("#gal_fetch_wpeditor_data").click();
                jQuery("#gal_fetch_wpeditor_data-html").click();
                var gal_fetch_wpelement_id = jQuery("#gal_fetch_wpelement").val();
                var gal_fetched_data = jQuery("#gal_fetch_wpeditor_data").val();
                jQuery(".gal_richeditbox_" + gal_fetch_wpelement_id).val(gal_fetched_data);
            }
        </script>
        <p><strong><?php _e( 'Tips', WL_GP_TEXTDOMAIN ); ?>
                :</strong> <?php _e( 'Plugin crop images with same size thumbnails. So, please upload all gallery images using Add New Image button. Dont use/add pre-uploaded images which are uploaded previously using Media/Post/Page.', WL_GP_TEXTDOMAIN ); ?>
        </p>
        <div style="text-align:left;color:#F8504B !important;">
            <p><?php _e( 'Please Review & Rate Us On WordPress', WL_GP_TEXTDOMAIN ); ?></p>
            <a class="upgrade-to-pro-demo fag-rate-us" style=" text-decoration: none; height: 40px; width: 40px;"
               href="https://wordpress.org/plugins/gallery-pro/" target="_blank">
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
            </a>
        </div>
        <div class="upgrade-to-pro-demo"
             style="text-align:left;margin-bottom:10px;margin-top:10px;color:#F8504B !important;">
            <a href="https://wordpress.org/plugins/gallery-pro/" target="_blank"
               class="button button-primary button-hero"><?php _e( 'RATE US', WL_GP_TEXTDOMAIN ); ?></a>
        </div>
		<?php
	}

	public function my_cpt() {
		$labels = array(
			'name'               => _x( 'Gallery Pro', 'post type general name' ),
			'singular_name'      => _x( 'Gallery Pro ', 'post type singular name' ),
			'menu_name'          => _x( 'Gallery Pro ', 'admin menu' ),
			'name_admin_bar'     => _x( 'Gallery Pro ', 'add new on admin bar' ),
			'add_new'            => __( 'Add New Gallery', WL_GP_TEXTDOMAIN ),
			'add_new_item'       => __( 'Add New Gallery', WL_GP_TEXTDOMAIN ),
			'new_item'           => __( 'New Gallery', WL_GP_TEXTDOMAIN ),
			'edit_item'          => __( 'Edit Gallery', WL_GP_TEXTDOMAIN ),
			'view_item'          => __( 'View Gallery', WL_GP_TEXTDOMAIN ),
			'all_items'          => __( 'All Galleries', WL_GP_TEXTDOMAIN ),
			'search_items'       => __( 'Search Galleries', WL_GP_TEXTDOMAIN ),
			'parent_item_colon'  => __( 'Parent Galleries:', WL_GP_TEXTDOMAIN ),
			'not_found'          => __( 'No Galleries found.', WL_GP_TEXTDOMAIN ),
			'not_found_in_trash' => __( 'No Galleries found in Trash.', WL_GP_TEXTDOMAIN )
		);

		$args = array(
			'labels'             => $labels,
			'description'        => __( 'Description', WL_GP_TEXTDOMAIN ),
			'public'             => false,
			'publicly_queryable' => true,
			'show_ui'            => true,
			'show_in_menu'       => true,
			'query_var'          => true,
			'menu_icon'          => 'dashicons-format-gallery',
			'rewrite'            => array( 'slug' => 'gallery' ),
			'capability_type'    => 'post',
			'has_archive'        => true,
			'hierarchical'       => false,
			'menu_position'      => 67,
			//'taxonomies'         =>  array('category'),
			'supports'           => array( 'title' )
		);

		register_post_type( 'acme_product', $args );
		add_filter( 'manage_edit-acme_product_columns', array( &$this, 'acme_product_columns' ) );
		add_action( 'manage_acme_product_posts_custom_column', array( &$this, 'acme_product_manage_columns' ), 10, 2 );
	}

	function acme_product_columns( $columns ) {
		$columns = array(
			'cb'        => '<input type="checkbox" />',
			'title'     => __( 'Gallery', WL_GP_TEXTDOMAIN ),
			'shortcode' => __( 'Gallery Shortcode', WL_GP_TEXTDOMAIN ),
			'author'    => __( 'Author', WL_GP_TEXTDOMAIN ),
			'date'      => __( 'Date', WL_GP_TEXTDOMAIN )
		);

		return $columns;
	}

	function acme_product_manage_columns( $column, $post_id ) {
		global $post;
		switch ( $column ) {
			case 'shortcode' :
				echo '<input type="text" value="[WG id=' . $post_id . ']" readonly="readonly" />';
				break;
			default :
				break;
		}
	}

	public function lks_admin_thumb( $id ) {
		$img1            = wp_get_attachment_image_src( $id, 'lksg_image_admin_original', true );
		$img_thumb       = wp_get_attachment_image_src( $id, 'lksg_gallery_admin_thumb', true );
		$img_medium      = wp_get_attachment_image_src( $id, 'lksg_gallery_admin_medium', true );
		$img_large       = wp_get_attachment_image_src( $id, 'lksg_gallery_admin_large', true );
		$img_medium_auto = wp_get_attachment_image_src( $id, 'lksg_gallery_admin_medium_auto', true );
		$img_large_auto  = wp_get_attachment_image_src( $id, 'lksg_gallery_admin_large_auto', true );
		$u_string        = substr( str_shuffle( "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ" ), 0, 5 );
		?>
        <li class="choose_image_entry">
            <a href="" class="lksgallery_remove_image">
                <img src="<?php echo WGP_PLUGIN_URL . 'images/Close-icon-new.png'; ?>"></a>
            <img src="<?php echo $img_thumb[0]; ?>">
            <input type="text" id="lksg_image_url[]" name="lksg_image_url[]" value="<?php echo esc_url( $img1[0] ); ?>"
                   readonly="readonly" style="display:none;"/>
            <input type="text" id="lksg_img_thumb[]" name="lksg_img_thumb[]" class="lksg_label_text"
                   value="<?php echo esc_url( $img_thumb[0] ); ?>" readonly="readonly" style="display:none;"/>
            <input type="text" id="lksg_img_medium[]" name="lksg_img_medium[]" class="lksg_label_text"
                   value="<?php echo esc_url( $img_medium[0] ); ?>" readonly="readonly" style="display:none;"/>
            <input type="text" id="lksg_img_large[]" name="lksg_img_large[]" class="lksg_label_text"
                   value="<?php echo esc_url( $img_large[0] ); ?>" readonly="readonly" style="display:none;"/>
            <input type="text" id="lksg_img_medium_auto[]" name="lksg_img_medium_auto[]" class="lksg_label_text"
                   value="<?php echo esc_url( $img_medium_auto[0] ); ?>" readonly="readonly" style="display:none;"/>
            <input type="text" id="lksg_img_large_auto[]" name="lksg_img_large_auto[]" class="lksg_label_text"
                   value="<?php echo esc_url( $img_large_auto[0] ); ?>" readonly="readonly" style="display:none;"/>

            <select name="lksg_portfolio_type[]" id="lksg_portfolio_type[]" style="width:100%;">
                <optgroup label="Select Type">
                    <option value="image" selected="selected"><i
                                class="fa fa-image"></i><?php _e( 'Image', WL_GP_TEXTDOMAIN ); ?> </option>
                    <option value="video"><i class="fa fa-youtube-play"></i><?php _e( 'Video', WL_GP_TEXTDOMAIN ); ?>
                    </option>
                    <option value="link"><i class="fa fa-link"></i><?php _e( 'Link', WL_GP_TEXTDOMAIN ); ?></option>
                </optgroup>
            </select>

            <label><?php _e( 'Label', WL_GP_TEXTDOMAIN ); ?></label>
            <input type="text" placeholder="Enter Image label" name="lksg_image_label[]" class="lksg_label_text">

            <label><?php _e( 'Video URL', WL_GP_TEXTDOMAIN ); ?> <a
                        href="http://weblizar.com/get-youtube-vimeo-video-url/"
                        target="_blank"><strong><?php _e( 'Help', WL_GP_TEXTDOMAIN ); ?></strong></a></label>
            <input type="text" id="lksg_video_link[]" name="lksg_video_link[]"
                   placeholder="<?php _e( 'Enter Youtube/Vimeo Video URL', WL_GP_TEXTDOMAIN ); ?>"
                   class="pgpp_label_text">

            <label><?php _e( 'Link', WL_GP_TEXTDOMAIN ); ?></label>
            <input type="text" id="lksg_external_link[]" name="lksg_external_link[]"
                   placeholder="<?php _e( 'Enter Link URL', WL_GP_TEXTDOMAIN ); ?>" class="lksg_label_text">

            <label><?php _e( 'Description', WL_GP_TEXTDOMAIN ); ?></label>
            <textarea name="img_desc[]" id="img_desc[]" placeholder="<?php _e( 'Description', WL_GP_TEXTDOMAIN ); ?>"
                      class="gal_richeditbox_<?php echo $id; ?>"></textarea>
            <button type="button" class="btn btn-md btn-info btn-block" data-toggle="modal" data-target="#myModalgp"
                    onclick="gal_richeditor(<?php echo $id; ?>)"><?php _e( 'Use Rich Text Editor', WL_GP_TEXTDOMAIN ); ?>
                <i class="fa fa-edit"></i></button>
        </li>
		<?php
	}

	public function lks_ajax_get_thumb() {
		echo $this->lks_admin_thumb( $_POST['imageid'] );
		die();
	}

	public function lksg_add_image_meta_box_save( $postid ) {
		if ( isset( $postid ) && isset( $_POST['lksg_wl_action'] ) ) {
			$total_img = count( $_POST['lksg_image_url'] );
			$img_array = array();

			if ( $total_img ) {
				for ( $i = 0; $i < $total_img; $i ++ ) {
					$img_label            = stripslashes( sanitize_text_field( $_POST['lksg_image_label'][ $i ] ) );
					$url                  = sanitize_text_field( $_POST['lksg_image_url'][ $i ] );
					$lksg_img_thumb       = sanitize_text_field( $_POST['lksg_img_thumb'][ $i ] );
					$lksg_img_medium      = sanitize_text_field( $_POST['lksg_img_medium'][ $i ] );
					$lksg_img_large       = sanitize_text_field( $_POST['lksg_img_large'][ $i ] );
					$lksg_img_medium_auto = sanitize_text_field( $_POST['lksg_img_medium_auto'][ $i ] );
					$lksg_img_large_auto  = sanitize_text_field( $_POST['lksg_img_large_auto'][ $i ] );
					$lksg_video_link      = sanitize_text_field( $_POST['lksg_video_link'][ $i ] );
					$lksg_external_link   = sanitize_text_field( $_POST['lksg_external_link'][ $i ] );
					$img_desc             = stripslashes( $_POST['img_desc'][ $i ] );
					$lksg_portfolio_type  = sanitize_text_field( $_POST['lksg_portfolio_type'][ $i ] );

					$img_array[] = array(
						'lksg_image_label'     => $img_label,
						'lksg_image_url'       => $url,
						'lksg_img_thumb'       => $lksg_img_thumb,
						'lksg_img_medium'      => $lksg_img_medium,
						'lksg_img_large'       => $lksg_img_large,
						'lksg_img_medium_auto' => $lksg_img_medium_auto,
						'lksg_img_large_auto'  => $lksg_img_large_auto,
						'lksg_video_link'      => $lksg_video_link,
						'lksg_external_link'   => $lksg_external_link,
						'lksg_portfolio_type'  => $lksg_portfolio_type,
						'img_desc'             => $img_desc
					);
					update_post_meta( $postid, 'lksg_all_photos_details', base64_encode( serialize( $img_array ) ) );
					update_post_meta( $postid, 'lksg_total_images_count', $total_img );
				}
			} else {
				$total_img   = 0;
				$img_array[] = array();
				update_post_meta( $postid, 'lksg_all_photos_details', base64_encode( serialize( $img_array ) ) );
				update_post_meta( $postid, 'lksg_total_images_count', $total_img );
			}
		}
	}

	public function lksg_settings_meta_save( $PostID ) {
		if ( isset( $PostID ) && isset( $_POST['lksg_action'] ) ) {
			$lk_gallery_title    = sanitize_option( 'lk-show-gallery-title', $_POST['lk-show-gallery-title'] );
			$lk_show_image_label = sanitize_option( 'lk-show-image-label', $_POST['lk-show-image-label'] );
			$lk_Gallery_Layout   = sanitize_option( 'lk-gallery-layout', $_POST['lk-gallery-layout'] );
			if(isset($_POST['wgp_Color'])){
				$wgp_Color           = sanitize_option( 'wgp_Color', $_POST['wgp_Color'] );
			}			
			$lk_label_Color      = sanitize_option( 'lk_label_Color', $_POST['lk_label_Color'] );
			$lk_desc_font_Color  = sanitize_option( 'lk_desc_font_Color', $_POST['lk_desc_font_Color'] );
			$lk_btn_Color        = sanitize_option( 'lk_btn_Color', $_POST['lk_btn_Color'] );
			$lk_btn_font_Color   = sanitize_option( 'lk_btn_font_Color', $_POST['lk_btn_font_Color'] );
			$lk_font_style       = sanitize_option( 'lk_font_style', $_POST['lk_font_style'] );
			$lk_Custom_CSS       = sanitize_text_field( $_POST['lk_Custom_CSS'] );
			$lk_show_img_desc    = sanitize_option( 'lk_show_img_desc', $_POST['lk_show_img_desc'] );
			$lk_Light_Box        = sanitize_option( 'lk_Light_Box', $_POST['lk_Light_Box'] );
			$lk_open_link        = sanitize_option( 'lk_open_link', $_POST['lk_open_link'] );
			$lk_button_title     = sanitize_option( 'lk_button_title', $_POST['lk_button_title'] );

			$lk_setting_array      = serialize( array(
				'lk_gallery_title'    => $lk_gallery_title,
				'lk_show_image_label' => $lk_show_image_label,
				'lk_Gallery_Layout'   => $lk_Gallery_Layout,
				'wgp_Color'           => $wgp_Color,
				'lk_label_Color'      => $lk_label_Color,
				'lk_desc_font_Color'  => $lk_desc_font_Color,
				'lk_btn_Color'        => $lk_btn_Color,
				'lk_btn_font_Color'   => $lk_btn_font_Color,
				'lk_font_style'       => $lk_font_style,
				'lk_Custom_CSS'       => $lk_Custom_CSS,
				'lk_show_img_desc'    => $lk_show_img_desc,
				'lk_Light_Box'        => $lk_Light_Box,
				'lk_open_link'        => $lk_open_link,
				'lk_button_title'     => $lk_button_title
			) );
			$lksg_Gallery_Settings = "lksg_Gallery_Settings_" . $PostID;
			update_post_meta( $PostID, $lksg_Gallery_Settings, $lk_setting_array );
		}
	}
}

global $lksg;
$lksg = lksg::forge();

require_once( "gallery-shortcode.php" );

add_action( 'media_buttons_context', 'lksg_custom_button', 17 );
add_action( 'admin_footer', 'lksg_inline_popup_content' );
function lksg_custom_button( $context ) {
	$btnimg           = WGP_PLUGIN_URL . '/images/Photos-icon.png';
	$lksgcontainer_id = 'lksg_div';
	//append the icon
	$context .= '<a class="button button-primary thickbox"  title="' . "Select Gallery to insert into post" . '"  
	href="#TB_inline?width=400&inlineId=' . $lksgcontainer_id . '">
	<span class="wp-media-buttons-icon" style="background: url(' . $btnimg . '); background-repeat: no-repeat; background-position: left bottom;"></span>
	Gallery Pro Shortcode</a>';

	return $context;
}

function lksg_inline_popup_content() { ?>
    <script type="text/javascript">
        jQuery(document).ready(function () {
            jQuery('#lksg_galleryinsert').on('click', function () {
                var id = jQuery('#lksg-gallery-select option:selected').val();
                window.send_to_editor('<p>[WG id=' + id + ']</p>');
                tb_remove();
            })
        });
    </script>
    <div id="lksg_div" style="display:none;">
        <h2><?php _e( 'Select Gallery To Insert Into Post', WL_GP_TEXTDOMAIN ); ?></h2>
		<?php
		$all_posts = wp_count_posts( 'acme_product' )->publish;
		$args      = array( 'post_type' => 'acme_product', 'posts_per_page' => $all_posts );
		global $lksg_galleries;
		$lksg_galleries = new WP_Query( $args );
		if ( $lksg_galleries->have_posts() ) { ?>
            <select id="lksg-gallery-select">
				<?php
				while ( $lksg_galleries->have_posts() ) : $lksg_galleries->the_post(); ?>
                    <option value="<?php echo esc_attr( get_the_ID() ); ?>"><?php the_title(); ?></option>
				<?php
				endwhile;
				?>
            </select>
            <button class='button primary'
                    id='lksg_galleryinsert'><?php _e( 'Insert Gallery Shortcode', WL_GP_TEXTDOMAIN ); ?></button>
			<?php
		} else {
			_e( 'No Gallery found', WL_GP_TEXTDOMAIN );
		}
		?>
    </div>
	<?php
}
?>